#pragma semicolon 1
#include <knife_choice_core>
#pragma newdecls required
#include <vip_core>
#include <clientprefs>

/*
* 	Типы ножей:
*	Default_CT 		= 1,
*	Default_T 		= 2,
*	Gold 			= 3,
*	Flip 			= 4,
*	Gut 			= 5,
*	Bayonet 		= 6,
*	M9 Bayonet 		= 7,
*	Karambit 		= 8,
*	Huntsman 		= 9,
*	Butterfly 		= 10,
*	Falchion 		= 11,
*	Shadow Daggers 	= 12,
*	Bowie 			= 13,
*	Ursus 			= 14,
*	Navaja 			= 15,
*	Stiletto 		= 16,
*	Talon 			= 17,
*	Ghost 			= 18,
*	Classic 		= 19,
*	Paracord 		= 20,
*	Survival 		= 21,
*	Nomad 			= 22,
*	Skeleton 		= 23,
*
*/

public Plugin myinfo =
{
	name = "[VIP] KNIFE",
	author = "Pheonix (˙·٠●Феникс●٠·˙), NaN",
	description = "Knife Choice Core support for VIP",
	version = "1.2",
	url = "zizt.ru, hlmod.ru"
};

#define VIP_KNIFE	"Knife"

Handle g_hCookie;
bool g_bAvailableKnifes[MAXPLAYERS+1][50];
int g_iKnifeID[MAXPLAYERS+1];

public void OnPluginStart()
{
	g_hCookie = RegClientCookie(VIP_KNIFE, VIP_KNIFE, CookieAccess_Public);
	if (VIP_IsVIPLoaded())
		VIP_OnVIPLoaded();
}

public void OnPluginEnd()
{
	if (CanTestFeatures() && GetFeatureStatus(FeatureType_Native, "VIP_UnregisterMe") == FeatureStatus_Available)
		VIP_UnregisterMe();
}

public void OnClientPutInServer(int iClient) { g_iKnifeID[iClient] = -1; }

public void VIP_OnVIPLoaded() { VIP_RegisterFeature(VIP_KNIFE, STRING, SELECTABLE, OnMenuOpen, OnItemDisplay); }

public void VIP_OnVIPClientLoaded(int iClient)
{
	if(VIP_IsClientFeatureUse(iClient, VIP_KNIFE))
	{
		char sInfo[64], id[5];
		VIP_GetClientFeatureString(iClient, VIP_KNIFE, sInfo, sizeof(sInfo));
		int maxid = KCC_GetKnifeMaxId();
		for (int i = 1; i <= maxid; i++)
		{
			IntToString(i, id, 5);
			if(StrContains(sInfo, id) != -1 || StrContains(sInfo, "all") != -1)
				g_bAvailableKnifes[iClient][i] = true;
			else
				g_bAvailableKnifes[iClient][i] = false;
		}
		GetClientCookie(iClient, g_hCookie, sInfo, sizeof(sInfo));
		if(sInfo[0])
			g_iKnifeID[iClient] = StringToInt(sInfo);
	}
}

public Action KCC_OnReceivesKnifePre(int iClient, knifes &kKnife, bool bHasKnife, bool bKnifeClient, bool bSetKnife)
{
	if(g_iKnifeID[iClient] != -1)
	{
		if(!bKnifeClient)
			return Plugin_Continue;
		else if(KCC_GetKnifeIdInType(kKnife) != g_iKnifeID[iClient])
		{
			kKnife = KCC_GetKnifeTypeInId(g_iKnifeID[iClient]);
			return Plugin_Changed;
		}
	}
	return Plugin_Continue;
}

public bool OnMenuOpen(int iClient, const char[] sFeatureName)
{
	Menu hMenu = new Menu(KnifeMenuHandler);
	SetMenuTitle(hMenu, "Выбор ножа\n ");
	int maxid = KCC_GetKnifeMaxId();
	char desc[64], id[10];
	for (int i = 1; i <= maxid; i++)
		if(g_bAvailableKnifes[iClient][i])
		{
			KCC_GetKnifeNameFromIndex(KCC_GetKnifeTypeInId(i), desc, sizeof(desc));
			IntToString(i, id, 10);
			AddMenuItem(hMenu, id, desc);
		}
	SetMenuExitBackButton(hMenu, true);
	DisplayMenu(hMenu, iClient, MENU_TIME_FOREVER);
	return false;
}

public bool OnItemDisplay(int iClient, const char[] sFeatureName, char[] sDisplay, int iMaxLength)
{
	char desc[64];
	if(g_iKnifeID[iClient] == -1)
		strcopy(desc, sizeof(desc), "Стандарт");
	else
		KCC_GetKnifeNameFromIndex(KCC_GetKnifeTypeInId(g_iKnifeID[iClient]), desc, sizeof(desc));
	FormatEx(sDisplay, iMaxLength, "Нож [%s]", desc);
	return true;
}

public int KnifeMenuHandler(Handle menu, MenuAction action, int param1, int param2)
{
	switch(action)
	{
		case MenuAction_Cancel:
			if(param2 == MenuCancel_ExitBack)
				VIP_SendClientVIPMenu(param1);
		case MenuAction_Select:
		{
			char sInfo[64];
			GetMenuItem(menu, param2, sInfo, sizeof(sInfo));
			g_iKnifeID[param1] = StringToInt(sInfo);
			SetClientCookie(param1, g_hCookie, sInfo);
			if(IsPlayerAlive(param1))
				KCC_SetKnife(param1, KCC_GetKnifeTypeInId(g_iKnifeID[param1]));
			VIP_SendClientVIPMenu(param1);
		}
		case MenuAction_End:
			CloseHandle(menu);
	}
}